public class NumberAlignments {

	public static void main(String[] args) {
		//Ueberpruefung der Eingabe Parameter
		if (args.length == 2) {
			try {
				int m = Integer.parseInt(args[0]);
				int n = Integer.parseInt(args[1]);
				// Aufrufe der verschiedenen Funktionen
				n_rekusive(m, n);
				n_approx(n);
				n_prime_exact(m,n);
				n_prime_approx(n);
			} catch (Exception e) {
				System.out
						.println("Eingabe kann nicht in int umgewandelt werden.");
			}
		} else if (args.length < 2) {
			System.out.println("Zu wenige Argumente eingegeben.");
		} else {
			System.out.println("Zu viele Argumente eingegeben.");
		}
	}

	// N(m,n) wird rekursiv berechnet
	public static void n_rekusive(int m, int n) {
		int x = rekursion(m, n);
		System.out.println("Rekursive Berechnung N von m = " + m + " und n = " + n
				+ " ergibt: " + x);
	}

	//Rekursive Funktion zur Berechnung von N(m,n)
	public static int rekursion(int m, int n) {
		if (m == 0 || n == 0) {
			return 1;
		}
		return (rekursion(m - 1, n - 1) + rekursion(m - 1, n) + rekursion(m,
				n - 1));
	}

	//N(n,n) wird approximativ berechnet
	public static void n_approx(double n) {
		double x = (1 / Math.sqrt(n))
				* Math.pow((1 + Math.sqrt(2)), ((2 * n) + 1));
		System.out.println("Approximative Berechnung N von m = n = " + n + " ergibt: "
				+ x);
	}

	// N'(m,n) wird exakt berechnet
	public static void n_prime_exact(int m, int n) {
		Double x = binom((m + n), n);
		System.out.println("Exakte Berechnung N' von m = "+m+" und n= " + n + " ergibt: " + x);
	}

	// Hilfsfunktion, die den Bionomialkoeffizienten berechnet
	public static Double binom(int n, int k) {
		return (fac(n) / (fac(k) * fac(n - k)));
	}

	//Hilfsfunktion, welche die Fakultaet einer Zahl berechnet
	public static Double fac(int x) {
		// wegen der grossen Zahlen, die durch die Multiplikation entstehen, muss mit 
		// Double gerechnet werden, um einen overflow zu vermeiden
		Double fac = 1.0;
		for (int i = x; i > 0; i--) {
			fac = fac * i;
		}
		return fac;
	}

	// N'(n,n) wird approximativ berechnet
	public static void n_prime_approx(int n) {
		double x = (Math.pow(4, n) / Math.sqrt(Math.PI * n))
		* Math.exp(-3 / (24 * n));
		System.out.println("Approximative Berechnung N' von m = n = " + n + " ergibt: "
				+ x);
	}
}
